package org.jeecg.modules.stm.audit.controller;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.stm.audit.entity.AuditCriteriaScores;
import org.jeecg.modules.stm.audit.entity.AuditTaskReport;
import org.jeecg.modules.stm.audit.service.IAuditCriteriaScoresService;
import org.jeecg.modules.stm.audit.service.IAuditTaskReportService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;
 
 
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

/**
 * @Description: 任务报告
 * @Author: jeecg-boot
 * @Date:   2024-12-21
 * @Version: V1.0
 */

@RestController
@RequestMapping("/audit/auditTaskReport")
@Slf4j
public class AuditTaskReportController extends JeecgController<AuditTaskReport, IAuditTaskReportService> {
	@Autowired
	private IAuditTaskReportService auditTaskReportService;
	@Autowired
	private IAuditCriteriaScoresService auditCriteriaScoresService;
	
	/**
	 * 分页列表查询
	 *
	 * @param auditTaskReport
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "任务报告-分页列表查询")

	@GetMapping(value = "/list")
	public Result<IPage<AuditTaskReport>> queryPageList(AuditTaskReport auditTaskReport,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<AuditTaskReport> queryWrapper = QueryGenerator.initQueryWrapper(auditTaskReport, req.getParameterMap());
		Page<AuditTaskReport> page = new Page<AuditTaskReport>(pageNo, pageSize);
		IPage<AuditTaskReport> pageList = auditTaskReportService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param auditTaskReport
	 * @return
	 */
	@AutoLog(value = "任务报告-添加")

	@PostMapping(value = "/add")
	public Result<AuditTaskReport> add(@RequestBody AuditTaskReport auditTaskReport) {
		auditTaskReportService.save(auditTaskReport);
		return Result.OK(auditTaskReport);
	}
	
	/**
	 *  编辑
	 *
	 * @param auditTaskReport
	 * @return
	 */
	@AutoLog(value = "任务报告-编辑")

	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<AuditTaskReport> edit(@RequestBody AuditTaskReport auditTaskReport) {
		String scoreKey = auditTaskReport.getScoreKey();
		//if(auditTaskReport.getScore()==null) {
		List<AuditCriteriaScores> list = auditCriteriaScoresService.lambdaQuery().eq(AuditCriteriaScores::getCode, scoreKey).list();
		if (list.size() > 0) {
			AuditCriteriaScores criteriaScores = list.get(0);
			auditTaskReport.setScore(criteriaScores.getVal().floatValue());
			auditTaskReport.setLevel(criteriaScores.getLevel());

		}
		//}
		auditTaskReportService.updateById(auditTaskReport);
		return Result.OK(auditTaskReport);
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "任务报告-通过id删除")

	@RequiresPermissions("audit:audit_task_report:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		auditTaskReportService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "任务报告-批量删除")

	@RequiresPermissions("audit:audit_task_report:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.auditTaskReportService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "任务报告-通过id查询")

	@GetMapping(value = "/queryById")
	public Result<AuditTaskReport> queryById(@RequestParam(name="id",required=true) String id) {
		AuditTaskReport auditTaskReport = auditTaskReportService.getById(id);
		if(auditTaskReport==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(auditTaskReport);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param auditTaskReport
    */
    @RequiresPermissions("audit:audit_task_report:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, AuditTaskReport auditTaskReport) {
        return super.exportXls(request, auditTaskReport, AuditTaskReport.class, "任务报告");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("audit:audit_task_report:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, AuditTaskReport.class);
    }

	 @PostMapping(value = "/batchAddOrUpdate")
	 public Result<String> batchAddOrUpdate(@RequestBody List<AuditTaskReport> list) {
		//List<AuditTaskReport> list = auditTaskReport.getReportList();
		if(list.size()>0) {
			auditTaskReportService.saveOrUpdateBatch(list);
		}
		 return Result.OK("保存成功！");
	 }

	 @GetMapping(value = "/queryAllReports")
	 public Result<Map<Integer,AuditTaskReport>> queryAllReports(AuditTaskReport auditTaskReport, HttpServletRequest req) {
		 QueryWrapper<AuditTaskReport> queryWrapper = QueryGenerator.initQueryWrapper(auditTaskReport, req.getParameterMap());
		 List<AuditTaskReport> list = auditTaskReportService.list(queryWrapper);
		 Map<Integer,AuditTaskReport> retMap = new HashMap<>();
		 for(AuditTaskReport report:list) {
			 retMap.put(report.getCheckItemId(),report);
		 }
		 return Result.OK(retMap);
	 }


	 @GetMapping(value = "/findAllTaskReport")
	 public Result<List<Map<String,Object>>> findAllTaskReport(AuditTaskReport auditTaskReport, HttpServletRequest req) {
		String  fid = req.getParameter("fileId");
		Integer fileId = fid==null?null:Integer.valueOf(fid);
		List<Map<String,Object>> list = auditTaskReportService.findAllTaskReport(auditTaskReport,fileId);
		return Result.OK(list);
	 }

 }
